program sapMP;

uses
  Windows,
  Messages,
  Forms,
  SysUtils,
  CommonTypes,
  Masks,
  unMain in 'unMain.pas' {sapMP_MainWindow},
  unEffects in 'unEffects.pas',
  unAbout in 'unAbout.pas' {abBox},
  unEffectsParams in 'unEffectsParams.pas' {sapMP_Effects},
  unInfo in 'unInfo.pas' {sapMP_Info},
  unPlayList in 'unPlayList.pas' {sapMP_PlayList},
  unData in 'unData.pas' {dmData: TDataModule},
  unConfig in 'unConfig.pas' {sapMPConfig};

{$R *.res}

var
 copydata : TCopyDataStruct;
 s        : string;
 HandleWindow : THandle;
 mpl : string;
begin

  CreateMutex(nil, FALSE, 'sapMP(c)bySuNofESoft');
  if GetLastError() <> 0 then
  begin
    if ParamCount=1 then
     if FileExists(ParamStr(1)) then
     begin
        HandleWindow := FindWindow('TsapMP_MainWindow',nil);
        if HandleWindow <>0 then
        begin
          s:=ParamStr(1);
          copydata.cbData:=length(s);
          copydata.lpData:=@s[1];
          SendMessage(HandleWindow,WM_COPYDATA,0,longint(@copydata));
        end;
     end;
    Halt;
  end;

  Application.Initialize;
  Application.CreateForm(TdmData, dmData);
  Application.CreateForm(TsapMP_MainWindow, sapMP_MainWindow);
  Application.CreateForm(TsapMP_Effects, sapMP_Effects);
  Application.CreateForm(TsapMP_Info, sapMP_Info);
  Application.CreateForm(TsapMP_PlayList, sapMP_PlayList);
  Application.CreateForm(TsapMPConfig, sapMPConfig);
  sapMP_MainWindow.LoadConfig;
  if FileExists(ParamStr(1)) then begin
//     ClearPlayList(sapMP_PlayList.PList);
     if MatchesMask(ParamStr(1),'*.pla') then sapMP_PlayList.PList.LoadPlaylist(ParamStr(1))
     else
     begin
      sapMP_PlayList.pList.Items.Add(ParamStr(1));
      sapMP_MainWindow.LoadSAPMusic(ParamStr(1));
      sapMP_MainWindow.StartBClick(nil);
     end;
  end else
  begin
    mpl := ExtractFileDir(Application.ExeName)+'\'+'sapMP.pla';
    if FileExists(mpl) then
    begin
      sapMP_PlayList.pList.LoadPlaylist(mpl);
    end;    
  end;
  Application.Run;
  
end.
