unit unMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, sapH, StdCtrls, dynamic_bass, Menus, CoolTrayIcon, ExtCtrls,
  ThdTimer, ActnList,  Spectrum_vis, CommonTypes,
  Buttons,   ShellApi, ImgList,
  JvComponent, JvTransBtn, JvTransBtn2,
  AJBFormCaption, JvSlider, JvMagnet, jpeg;

const MaxBuff = 44100;
      MaxStream = MaxBuff * 4;
      Title =' sapMP v 2.0 beta 1 by SuN';

      maxp: float = 1.3;      // increase tempo/rate for max 30%
      minp: float = 0.7;      // decrease tempo/rate for min 30%
       
type

  TsapMP_MainWindow = class(TForm)
    OpenDialog1: TOpenDialog;
    Effect_Reverb: TJvTransparentButton;
    Effect_Chorus: TJvTransparentButton;
    Effect_Compresor: TJvTransparentButton;
    Effect_Echo: TJvTransparentButton;
    Effect_Distortion: TJvTransparentButton;
    Effect_Flanger: TJvTransparentButton;
    Effect_Gargle: TJvTransparentButton;
    ActionList1: TActionList;
    acReverb: TAction;
    acChorus: TAction;
    acCompressor: TAction;
    acEcho: TAction;
    acDistortion: TAction;
    acFlanger: TAction;
    acGargle: TAction;
    Timer1: TThreadedTimer;
    acInfo: TAction;
    acConfig: TAction;
    acPlist: TAction;
    PaintFrame: TPaintBox;
    Timer2: TTimer;
    Timer3: TTimer;
    TrayIcon: TCoolTrayIcon;
    MainMenu: TPopupMenu;
    acAbout: TAction;
    acAbout1: TMenuItem;
    N1: TMenuItem;
    Play1: TMenuItem;
    i1: TMenuItem;
    N2: TMenuItem;
    Effects1: TMenuItem;
    acEffectsParams: TAction;
    Effectsparameters1: TMenuItem;
    acExit: TAction;
    N3: TMenuItem;
    Exit1: TMenuItem;
    pmEfReverb: TMenuItem;
    pmEfChorus: TMenuItem;
    pmEfCompresor: TMenuItem;
    pmEfEcho: TMenuItem;
    pmEfDistortion: TMenuItem;
    pmEfFlanger: TMenuItem;
    pmEfGargle: TMenuItem;
    Options1: TMenuItem;
    acPreferences: TAction;
    Preferences1: TMenuItem;
    Effect_Rotate: TJvTransparentButton;
    acRotate: TAction;
    Rotate1: TMenuItem;
    EAX1: TMenuItem;
    Generic1: TMenuItem;
    PaddedCell1: TMenuItem;
    Room1: TMenuItem;
    Bathroom1: TMenuItem;
    LivingRoom1: TMenuItem;
    StoneRoom1: TMenuItem;
    Auditorium1: TMenuItem;
    ConcertHall1: TMenuItem;
    Cave1: TMenuItem;
    Arena1: TMenuItem;
    Hangar1: TMenuItem;
    CarpetedHallway1: TMenuItem;
    Hallway1: TMenuItem;
    StoneCorridor1: TMenuItem;
    Alley1: TMenuItem;
    Forest1: TMenuItem;
    City1: TMenuItem;
    Mountains1: TMenuItem;
    Quarry1: TMenuItem;
    Plain1: TMenuItem;
    Parking1: TMenuItem;
    SewerPipe1: TMenuItem;
    Underwater1: TMenuItem;
    Drugged1: TMenuItem;
    Dizzy1: TMenuItem;
    Psychotic1: TMenuItem;
    Off1: TMenuItem;
    PrevB: TJvTransparentButton2;
    StartB: TJvTransparentButton2;
    AJBFormCaption1: TAJBFormCaption;
    PCaption: TPanel;
    CaptionBar: TPanel;
    CloseB: TJvTransparentButton;
    InfoB: TJvTransparentButton;
    JvTransparentButton22: TJvTransparentButton2;
    StopB: TJvTransparentButton2;
    NextB: TJvTransparentButton2;
    VolumeBar: TJvSlider;
    JvFormMagnet1: TJvFormMagnet;
    P1: TMenuItem;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure LoadBClick(Sender: TObject);
    procedure StartBClick(Sender: TObject);
    procedure StopBClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CloseBClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HeaderDblClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure VolumeBarChange(Sender: TObject);
    procedure Effect_ReverbClick(Sender: TObject);
    procedure Effect_ChorusClick(Sender: TObject);
    procedure Effect_CompresorClick(Sender: TObject);
    procedure Effect_EchoClick(Sender: TObject);
    procedure Effect_DistortionClick(Sender: TObject);
    procedure Effect_FlangerClick(Sender: TObject);
    procedure Effect_GargleClick(Sender: TObject);
    procedure PrevBClick(Sender: TObject);
    procedure NextBClick(Sender: TObject);
    procedure acReverbExecute(Sender: TObject);
    procedure acChorusExecute(Sender: TObject);
    procedure acCompressorExecute(Sender: TObject);
    procedure acEchoExecute(Sender: TObject);
    procedure acDistortionExecute(Sender: TObject);
    procedure acFlangerExecute(Sender: TObject);
    procedure acGargleExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure WMWindowPosChanging(var Message: TWMWindowPosChanging); message WM_WINDOWPOSCHANGING;
    procedure acInfoExecute(Sender: TObject);
    procedure acConfigExecute(Sender: TObject);
    procedure PlayLBClick(Sender: TObject);
    procedure EffectsBClick(Sender: TObject);
    procedure PaintFrameClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure TrayIconClick(Sender: TObject);
    procedure TrayIconStartup(Sender: TObject; var ShowMainForm: Boolean);
    procedure acAboutExecute(Sender: TObject);
    procedure acEffectsParamsExecute(Sender: TObject);
    procedure acExitExecute(Sender: TObject);
    procedure MainMenuPopup(Sender: TObject);
    procedure acPreferencesExecute(Sender: TObject);
    procedure Effect_RotateClick(Sender: TObject);
    procedure tbTempoChange(Sender: TObject);
    procedure acRotateExecute(Sender: TObject);
    procedure Psychotic1Click(Sender: TObject);
    procedure tbTempoDblClick(Sender: TObject);
    procedure VolumeBarStopChanged(Sender: TObject);
    procedure acPlistExecute(Sender: TObject);

  private
    { Private declarations }
   procedure LOADFILE(var Message : TWMCOPYDATA); message WM_COPYDATA;
   procedure ClearXBack;
   procedure UpdateButtons(Step : Integer = 0);
   procedure UpdateEffects(Sender : TObject);

   procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  public
    { Public declarations }
    SineStream: DWORD;
    skButtons : TBitmap;
    SilenceStep : integer;

    procedure LoadSAPMusic(fn : String; AutoPlay : Byte = 0);
    procedure InitializeSkin;
    procedure AddToPlayList(fn :String; Clear : Boolean = False);
    procedure DrawScroll;
    procedure DrawPlayTime;
    procedure ClearPlayTime;
    function  EndOfSong : Boolean;
    function  CheckSilence:Boolean;
    procedure LoadConfig;
    procedure SaveConfig;
    procedure JumpToNext;
  end;

type
  PSmallInt = ^SmallInt;

procedure RegisterExtensions;

var
  MinimizeToTray : Boolean;
  playBuffer : array[0..44100] of byte;
  sapMP_MainWindow: TsapMP_MainWindow;
  HFX_REV,
  HFX_CHOR,
  HFX_COMPRES,
  HFX_ECHO,
  HFX_DISTOR,
  HFX_FLANGER,
  HFX_GARGLE  : HFX;
  HFX_ROTATE: HDSP;            // DSP handle
  cFile : PsapMUSICstrc;
  currentFile : TsapMUSICstrc;
  currentsong, MaxSongs : integer;

  i : integer;

  Saved8087CW: Word;
  Minim      : Boolean;
  MaxHeight,
  MaxWidth   : Integer;

  xBack      : TBitmap;
  xDisplay   : TBitmap;
  tmpCaption : String;
  nam        : String;
  FFTFata    : TFFTData;
  VolumeControl : Integer;

  IsPlaying     : Boolean;

  CpuTime    : String;

  MonoNdx,
  SterNdx  : Integer;
  PlayTime : TTime;
  SongTime : TTime;

  SongSilence : integer;  
  scrolls  : String;
implementation
{$R *.dfm}
{$R sapBitmap.res}
uses unAbout,
     unEffectsParams,
     unInfo,
     unPlayList,
     Masks,
     Registry,
     unData,
     DateUtils,
     IniFiles, unConfig;

function MakeSap(handle: HSTREAM; buffer: Pointer; length: DWORD; user: DWORD): DWORD; stdcall;
begin
 sapRenderBuffer(buffer,(length div 4)-1);
// CpuTime := Format(' CPU : %3.2f',[RT_BASS_GetCPU]);
 Result := length;
end;

procedure RegisterExtensions;
var
  Reg : TRegistry;
  CurrString : String;
begin
  Reg := TRegistry.Create;  // odpalenie rejestru
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;  // ustawienie kucza glownego
    Reg.OpenKey('sapMPSAP.file\DefaultIcon', True);
    Reg.WriteString('',Application.ExeName+',1');
    Reg.CloseKey;

    Reg.OpenKey('sapMPSAP.file\shell\open',True);
    Reg.WriteString('','&Otwrz');
    Reg.CloseKey;

    Reg.OpenKey('sapMPSAP.file\shell\open\command', True);
    Reg.WriteString('',Application.ExeName+' %1');
    Reg.CloseKey;

    Reg.OpenKey('sapMPPlayList.file\DefaultIcon', True);
    Reg.WriteString('',Application.ExeName+',2');
    Reg.CloseKey;

    Reg.OpenKey('sapMPPlayList.file\shell\open',True);
    Reg.WriteString('','&Otwrz');
    Reg.CloseKey;

    Reg.OpenKey('sapMPPlayList.file\shell\open\command', True);
    Reg.WriteString('',Application.ExeName+' %1');
    Reg.CloseKey;

    Reg.RootKey := HKEY_LOCAL_MACHINE;  // ustawienie kucza glownego
    Reg.OpenKey('SOFTWARE\Classes\.sap', True);
    Reg.WriteString('','sapMPSAP.file');
    Reg.CloseKey;
    Reg.OpenKey('SOFTWARE\Classes\.sap', True);
    Reg.WriteString('','sapMPSAP.file');
    Reg.CloseKey;
    Reg.OpenKey('SOFTWARE\Classes\.pla', True);
    Reg.WriteString('','sapMPPlayList.file');
    Reg.CloseKey;

  finally
    Reg.Free; // zwolnienie rejestru
  end;
end;


function GetCharIndex(c: char):Integer;
var b:byte;
begin
     b:=ord(c);
     Result := 28;
     if (b>64) and (b<91) then Result:=(b-65);
     if (b>47) and (b<58) then Result:=(b-48)+29;
     if b=33 then Result := 46;// !
     if b=34 then  Result := 26;
     if b=37 then Result := 55;// %
     if b=39 then Result := 45;// '
     if b=40 then Result := 42;
     if b=41 then Result := 43;
     if b=42 then Result := 64;
     if b=43 then Result := 48;// +
     if b=45 then Result := 44;
     if b=46 then Result := 56;// .
     if b=47 then Result := 50;// /
     if b=58 then Result := 41;// :
     if b=64 then  Result := 27;
     if b=92 then Result := 49;// \
     if b=95 then Result := 39;
end;

procedure TsapMP_MainWindow.WMWindowPosChanging(var Message: TWMWindowPosChanging);
var xx,
    yy:Integer;
begin
  xx:=Message.WindowPos.x;
  yy:=Message.WindowPos.y;
  if (xx<>0) or (yy<>0) then begin
    if Assigned(sapMP_Info) then sapMP_Info.SetWPos(xx,yy);
  end;  
end;

procedure TsapMP_MainWindow.WMDropFiles(var Msg: TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
  _Files,
       i : Integer;
  fn : string;
  FileAttrib : DWord;
begin
  try
    _Files := DragQueryFile(Msg.Drop, $FFFFFFFF, CFileName, MAX_PATH);
    if _Files > 0 then begin
      for i := 0 to _Files-1 do begin
         FillChar(CFileName,MAX_PATH,0);
         DragQueryFile(Msg.Drop, i , CFileName, MAX_PATH);
         FileAttrib := GetFileAttributes(CFileName);
// FILE_ATTRIBUTE_DIRECTORY
         if (FileAttrib and FILE_ATTRIBUTE_DIRECTORY = FILE_ATTRIBUTE_DIRECTORY) then
          // Directory
         else
         if (FileAttrib and FILE_ATTRIBUTE_NORMAL = FILE_ATTRIBUTE_NORMAL ) or (FileAttrib and FILE_ATTRIBUTE_ARCHIVE = FILE_ATTRIBUTE_ARCHIVE)
         or (FileAttrib and FILE_ATTRIBUTE_READONLY = FILE_ATTRIBUTE_READONLY) then
         begin
          if MatchesMask(CFileName,'*.sap') then sapMP_PlayList.pList.Items.Add(CFileName);
          if MatchesMask(CFileName,'*.pla') then sapMP_PlayList.PList.LoadPlaylist(CFileName);
         end;
      end;
     fn := sapMP_PlayList.pList.GetItem(Random(sapMP_PlayList.Plist.Count-1));
     if fn<>'' then LoadSAPMusic(fn);
     Msg.Result := 0;
    end;
  finally
    DragFinish(Msg.Drop);
  end;
end;


procedure TsapMP_MainWindow.ClearXBack;
var
 r : Trect;
begin

 xBack.Width := PaintFrame.Width;
 xBack.Height := PaintFrame.Height;
 xBack.LoadFromResourceName(hinstance,'ATARI2');
end;

procedure TsapMP_MainWindow.UpdateButtons(Step : Integer = 0);
var be : Boolean;
begin
 Timer3.Enabled := False;
 be := MaxSongs <>0;
 case step of
  -1 : currentsong := currentsong - Integer((currentsong>0));
   1 : currentsong := currentsong + Integer((currentsong<MaxSongs));
 end;


// Songs.Caption :=Format(' Song %.2d of %.2d',[CurrentSong+1,MaxSongs+1]);
{ PrevB.Enabled := be and (currentSong>0);
 NextB.Enabled := be and (currentSong<MaxSongs);
}
 if step = 0 then Exit;

 if isPlaying then begin
         StopBClick(Self);
         sapPlaySong(currentsong);
         StartBClick(Self);
 end
 else
  sapPlaySong(currentsong);
 Timer3.Enabled := True;
end;

procedure TsapMP_MainWindow.InitializeSkin;
begin
//  skButtons.LoadFromFile(ExtractFileDir(Application.ExeName)+'\skin\default\buttons.bmp');
  dmData.ButtonsList.FileLoad(rtBitmap,ExtractFileDir(Application.ExeName)+'\skin\default\buttons.bmp',clNone);
{

  SetButtonL(PrevB,0);
  SetButtonL(StartB,1);
  SetButtonL(StopB,3);
  SetButtonL(NextB,4);
  SetButtonS(LoadB,5);
}
{  dmData.PlayLImage.GetBitmap(0,PlayLB.PicIdle.Bitmap);
  dmData.PlayLImage.GetBitmap(0,PlayLB.PicUp.Bitmap);
  dmData.PlayLImage.GetBitmap(1,PlayLB.PicDown.Bitmap);
}
{  dmData.EffectsLImage.GetBitmap(0,EffectsB.PicIdle.Bitmap);
  dmData.EffectsLImage.GetBitmap(0,EffectsB.PicUp.Bitmap);
  dmData.EffectsLImage.GetBitmap(1,EffectsB.PicDown.Bitmap);
}  
end;


procedure TsapMP_MainWindow.FormCreate(Sender: TObject);
var
 IniFile : TIniFile;
begin

 Application.HintPause := 200;
 Application.HintHidePause := 3000;
 // Check that BASS_FX v1.2 was loaded

 TrayIcon.Hint := Title;
 TrayIcon.ShowBalloonHint('sapMP Message','Initialization...',bitInfo,10);
 MinimizeToTray := False;
 skButtons := TBitmap.Create;
 xDisplay  := TBitmap.Create;
 xBack := TBitmap.Create;

 xDisplay.Width := 160;
 xDisplay.Height := 15;

 InitializeSkin;

 Caption := Title;
 CaptionBar.Caption := Caption;
 Application.Title := Title;
 Minim := False;
 LoadDll;
 Load_BASSDLL(ExtractFileDir(Application.ExeName)+'\bass.dll');
 if not BASS_Init(1, 44000, BASS_DEVICE_3D, handle,nil) then ShowMessage('Kupa');
 BASS_Start;

 Spectrum    := TSpectrum.Create(PaintFrame.Width, PaintFrame.Height);
 Spectrum.Mode := 1;
 Spectrum.Pen  := clLime;
 Spectrum.Peak := clSilver;

 MaxHeight := Height;
 MaxWidth  := Width;

 ClearXBack;
 Spectrum.SetBackGround(True,xBack);
 FillChar(FFTFata,SizeOf(FFTFata),0);

 VolumeControl := BASS_GetVolume;
{ VolumeControl := BASS_GetVolume;}
 VolumeBar.Position := VolumeControl;
 IsPlaying := False;

 DragAcceptFiles(sapMP_MainWindow.Handle,True);

 HFX_REV :=0;
 HFX_CHOR:=0;
 HFX_COMPRES:=0;
 HFX_ECHO:=0;
 HFX_DISTOR:=0;
 HFX_FLANGER:=0;
 HFX_GARGLE:=0;

 MonoNdx := 3;
 SterNdx := 1;

 RegisterExtensions;
 Scrolls := StringOfChar(' ',30)+Title;
 Timer3.Enabled := True;
 ClearPlayTime;
 PlayListMode := plmRandom;
 MusicLoaded := False;

 TrayIcon.HideBalloonHint;

{ tbTempo.maxValue := round((maxp - 1) * 100);
 tbTempo.minValue := round((minp - 1) * 100);
 tbTempo.Value := 0;
}
end;


procedure TsapMP_MainWindow.LoadSAPMusic;
var
 tl : TStringList;
begin
    StopBClick(Self);
    SongSilence := 0;
    currentFile := sapLoadMusicFile(fn);
    currentsong := currentFile.defSong;
    MusicLoaded := True;
    MaxSongs :=0;
    if currentFile.numOfSongs<> -1 then maxSongs := currentFile.numOfSongs-1;

    if currentsong = -1 then currentsong := 0;
    if currentsong > MaxSongs then currentSong := MaxSongs;
//    sapPlaySong(0);
    UpdateButtons(0);

    tl := TStringList.Create;
    tl.Text := currentFile.commentBuffer;
    try
     nam := tl.Strings[0];
     Delete(nam,1,7);
//    Delete(nam,Length(nam),1);
     SongInfo.Author :=nam;
     SongInfo.FileName := fn;
     nam := tl.Strings[1];
     Delete(nam,1,5);
//    Delete(nam,Length(nam),1);
     SongInfo.Title := nam;
     SongInfo.Stereo := currentFile.isStereo;
    except
    end;

    try
    nam := tl.Strings[2];
    Delete(nam,1,6);
    Delete(nam,Length(nam),1);
    SongInfo.Date := nam;
    except
    end;

    tl.Free;
    sapMP_Info.UpdateInfo;

    if SongInfo.Stereo then begin
         MonoNdx := 3;
         SterNdx := 0;
    end
    else
    begin
         MonoNdx := 2;
         SterNdx := 1;
    end;

    if PlayingItem <> nil then
      Scrolls := StringOfChar(' ',30)+'*** '+IntToStr(PlayingItem.Index+1)+'. '+SongInfo.Author+' - '+SongInfo.Title+' ***'
    else
      Scrolls := StringOfChar(' ',30)+'*** '+SongInfo.Author+' - '+SongInfo.Title+' ***';

    dmData.MonoSterL.Draw(Canvas,Width-10-58,40,MonoNdx);
    dmData.MonoSterL.Draw(Canvas,Width-10-29,40,SterNdx);

//
  case Minim of
   True  : begin
            if SongInfo.Title<>'' then begin
               Caption := ' sapMP - '+SongInfo.Title;
               CaptionBar.Caption := Caption;
               Application.Title := Caption;
            end;
           end;
   False : begin
             Caption := Title;
             CaptionBar.Caption := Caption;
             Application.Title := Caption;
           end;
  end;
//
  if AutoPlay =1 then StartBClick(Self);

end;

procedure TsapMP_MainWindow.LoadBClick(Sender: TObject);
begin
 if OpenDialog1.Execute then begin
  LoadSAPMusic(OpenDialog1.FileName);
  AddToPlayList(OpenDialog1.FileName);
 end;
end;

procedure TsapMP_MainWindow.StartBClick(Sender: TObject);
var sn:string;
begin
  if not MusicLoaded then begin
//     sn := GetPlayListitem(sapMP_PlayList.PList,True);
     if sn = '' then Exit;
     if sn<>'' then LoadSAPMusic(sn,0);
  end;
  ClearPlayTime;
  Timer1.Enabled := True;
  Timer2.Enabled := True;
  Timer3.Enabled := True;

  BASS_Start;
{  BASS_Start;}
  SineStream := BASS_StreamCreate(44100,2, 0, @MakeSap, 0);
//  if SineStream = 0 then ShowMessage('Kupa');
//  UpdateEffects(nil);
  if not BASS_StreamPlay(SineStream, False, 0) then ShowMEssage('Kupa 1');
  StartB.Enabled:=False;
  isPlaying := True;
end;

procedure TsapMP_MainWindow.StopBClick(Sender: TObject);
begin
 BASS_StreamFree(SineStream);
 BASS_Stop;
 sapPlaySong(currentsong);
 StartB.Enabled := True;
 isPlaying := False;
// Timer1.Enabled := False;
 Timer2.Enabled := False;
 Timer3.Enabled := False;
 ClearPlayTime;
end;

procedure TsapMP_MainWindow.Timer1Timer(Sender: TObject);
begin
 if Minim then Exit;
 if BASS_ChannelIsActive(SineStream) <>1 then
{ if BASS_ChannelIsActive(SineStream) <>1 then}
  FillChar(FFTFata,Sizeof(FFTFata),0)
 else
//    BASS_ChannelGetData(SineStream, @FFTFata, BASS_DATA_FFT2048);
    BASS_ChannelGetData(SineStream, @FFTFata, BASS_DATA_FFT1024);
//
  if not CheckSilence then SilenceStep := 6;
  Spectrum.Draw (PaintFrame.Canvas.Handle, FFTFata, 10, 0, False);
end;

procedure TsapMP_MainWindow.CloseBClick(Sender: TObject);
begin
 Close;
end;

procedure TsapMP_MainWindow.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Timer1.Enabled := False;
 BASS_Stop;

 BASS_Free;

 SaveConfig;
 Unload_BASSDLL;
 FreeDLL();
end;

procedure TsapMP_MainWindow.HeaderDblClick(Sender: TObject);
begin
 //
 //  Switch window
 //
  Minim := not Minim;

  case Minim of
   True  : begin
            if SongInfo.Title<>'' then begin
               Caption := ' sapMP - '+SongInfo.Title;
               CaptionBar.Caption := Caption;
               Application.Title := Caption;
            end;   
            Width := MaxWidth;
//            Height := Header.Height-2;
           end;
   False : begin
             Caption := Title;
               CaptionBar.Caption := Caption;
             Application.Title := Caption;
             Width := maxWidth;
//             Height := MaxHeight;
           end;
  end;
end;

procedure TsapMP_MainWindow.FormPaint(Sender: TObject);
var
  r : TRect;
begin
 if not Timer1.Enabled then Spectrum.Draw (PaintFrame.Canvas.Handle, FFTFata, 10, 0);
  Canvas.Brush.Color := clSilver;
  r := Rect(0,0,Width,Height);
  Canvas.FrameRect(r);
  r := Rect(1,1,Width-1,Height-1);
  Canvas.FrameRect(r);

  dmData.MonoSterL.Draw(Canvas,Width-10-58,40,MonoNdx);
  dmData.MonoSterL.Draw(Canvas,Width-10-29,40,SterNdx);

  DrawScroll;
end;

procedure TsapMP_MainWindow.VolumeBarChange(Sender: TObject);
var
 cp : TPoint;
begin
  VolumeControl := VolumeBar.Position;
  BASS_SetVolume(VolumeControl);
end;

procedure TsapMP_MainWindow.Effect_ReverbClick(Sender: TObject);
begin
 UpdateEffects(Sender);
end;

procedure TsapMP_MainWindow.Effect_ChorusClick(Sender: TObject);
begin
 UpdateEffects(Sender);
end;


procedure TsapMP_MainWindow.Effect_CompresorClick(Sender: TObject);
begin
 UpdateEffects(Sender);
end;

procedure TsapMP_MainWindow.Effect_EchoClick(Sender: TObject);
begin
 UpdateEffects(Sender);
end;

procedure TsapMP_MainWindow.Effect_DistortionClick(Sender: TObject);
begin
 UpdateEffects(Sender);
end;

procedure TsapMP_MainWindow.Effect_FlangerClick(Sender: TObject);
begin
 UpdateEffects(Sender);
end;

procedure TsapMP_MainWindow.Effect_GargleClick(Sender: TObject);
begin
 UpdateEffects(Sender);
end;

{=================================================}

procedure TsapMP_MainWindow.UpdateEffects(Sender : TObject);
var
 tv : integer;
begin

 if BASS_ChannelIsActive(SineStream) = 0 then Exit;

 tv := 0;

 if Sender is TJvTransparentButton then
 begin
    TJvTransparentButton(Sender).Down := not TJvTransparentButton(Sender).Down; 
    tv := TJvTransparentButton(Sender).Tag;
 end;


 if tv = 0 then
 begin
   if Effect_Reverb.Down then HFX_REV := BASS_ChannelSetFX(SineStream,BASS_FX_REVERB);
   if Effect_Chorus.Down then HFX_CHOR := BASS_ChannelSetFX(SineStream, BASS_FX_CHORUS);
   if Effect_Compresor.Down then HFX_COMPRES := BASS_ChannelSetFX(SineStream, BASS_FX_COMPRESSOR);
   if Effect_Echo.Down then HFX_ECHO := BASS_ChannelSetFX(SineStream, BASS_FX_ECHO);
   if Effect_Distortion.Down then HFX_DISTOR := BASS_ChannelSetFX(SineStream, BASS_FX_DISTORTION);
   if Effect_Flanger.Down then HFX_FLANGER := BASS_ChannelSetFX(SineStream, BASS_FX_FLANGER);
   if Effect_Gargle.Down then HFX_GARGLE := BASS_ChannelSetFX(SineStream, BASS_FX_GARGLE);

{   if Effect_Reverb.Down then HFX_REV := BASS_ChannelSetFX(SineStream,BASS_FX_REVERB);
   if Effect_Chorus.Down then HFX_CHOR := BASS_ChannelSetFX(SineStream, BASS_FX_CHORUS);
   if Effect_Compresor.Down then HFX_COMPRES := BASS_ChannelSetFX(SineStream, BASS_FX_COMPRESSOR);
   if Effect_Echo.Down then HFX_ECHO := BASS_ChannelSetFX(SineStream, BASS_FX_ECHO);
   if Effect_Distortion.Down then HFX_DISTOR := BASS_ChannelSetFX(SineStream, BASS_FX_DISTORTION);
   if Effect_Flanger.Down then HFX_FLANGER := BASS_ChannelSetFX(SineStream, BASS_FX_FLANGER);
   if Effect_Gargle.Down then HFX_GARGLE := BASS_ChannelSetFX(SineStream, BASS_FX_GARGLE);
}   if Effect_Rotate.Down then begin
            rotpos := 0.7853981;
            HFX_ROTATE := BASS_ChannelSetDSP(SineStream, Rotate, 0,1);
   end;
 end;

{REVERB}
 if tv = 1 then
  case Effect_Reverb.Down of
   True : HFX_REV := BASS_ChannelSetFX(SineStream,BASS_FX_REVERB);
   False: begin
           if HFX_REV <> 0 then BASS_ChannelRemoveFX(SineStream,HFX_REV);
           HFX_REV := 0;
          end;
  end;
{CHORUS}
 if tv = 2 then
  case Effect_Chorus.Down of
   True : HFX_CHOR := BASS_ChannelSetFX(SineStream, BASS_FX_CHORUS);
   False: begin
           if HFX_CHOR <> 0 then BASS_ChannelRemoveFX(SineStream,HFX_CHOR);
           HFX_CHOR:= 0;
          end;
  end;
{COMPRESOR}
 if tv = 3 then
  case Effect_Compresor.Down of
   True : HFX_COMPRES := BASS_ChannelSetFX(SineStream, BASS_FX_COMPRESSOR);
   False: begin
           if HFX_COMPRES <> 0 then BASS_ChannelRemoveFX(SineStream,HFX_COMPRES);
           HFX_COMPRES:= 0;
          end;
  end;
{ECHO}
 if tv = 4 then
  case Effect_Echo.Down of
   True : HFX_ECHO := BASS_ChannelSetFX(SineStream, BASS_FX_ECHO);
   False: begin
           if HFX_ECHO <> 0 then BASS_ChannelRemoveFX(SineStream,HFX_ECHO);
           HFX_ECHO:= 0;
          end;
  end;
{DISTORTION}
 if tv = 5 then
  case Effect_Distortion.Down of
   True : HFX_DISTOR := BASS_ChannelSetFX(SineStream, BASS_FX_DISTORTION);
   False: begin
           if HFX_DISTOR <> 0 then BASS_ChannelRemoveFX(SineStream,HFX_DISTOR);
           HFX_DISTOR:= 0;
          end;
  end;
{FLANGER}
 if tv = 6 then
  case Effect_Flanger.Down of
   True : HFX_FLANGER := BASS_ChannelSetFX(SineStream, BASS_FX_FLANGER);
   False: begin
           if HFX_FLANGER <> 0 then BASS_ChannelRemoveFX(SineStream,HFX_FLANGER);
           HFX_FLANGER:= 0;
          end;
  end;
{GARGLE}
 if tv = 7 then
  case Effect_Gargle.Down of
   True : HFX_GARGLE := BASS_ChannelSetFX(SineStream, BASS_FX_GARGLE);
   False: begin
           if HFX_GARGLE <> 0 then BASS_ChannelRemoveFX(SineStream,HFX_GARGLE);
           HFX_GARGLE := 0;
          end;
  end;
 {Rotate}
  if tv = 8 then
   case Effect_Rotate.Down of
    true : begin
            rotpos := 0.7853981;
            HFX_ROTATE := BASS_ChannelSetDSP(SineStream, Rotate, 0,1);
           end;
    false : BASS_ChannelRemoveDSP(SineStream, HFX_ROTATE);
  end; //case

  sapMP_Effects.UpdateParams;
end;
{=================================================}

procedure TsapMP_MainWindow.PrevBClick(Sender: TObject);
var sn : string;
begin
 UpdateButtons(-1);
 sn := SongInfo.FileName;
 if LoadSongFromPlayList(sapMP_PlayList.PList,sn,False) then
 begin
   StopBClick(nil);
   LoadSAPMusic(sn);
   StartBClick(nil);
 end;
end;

procedure TsapMP_MainWindow.NextBClick(Sender: TObject);
var sn : string;
begin
 UpdateButtons(-1);
 sn := SongInfo.FileName;
 if LoadSongFromPlayList(sapMP_PlayList.PList,sn,True) then
 begin
   StopBClick(nil);
   LoadSAPMusic(sn);
   StartBClick(nil);
 end;
end;

procedure TsapMP_MainWindow.acReverbExecute(Sender: TObject);
begin
 if BASS_ChannelIsActive(SineStream) = 0 then Exit;
 Effect_Reverb.Down := not Effect_Reverb.Down;
 Effect_ReverbClick(Self);
end;

procedure TsapMP_MainWindow.acChorusExecute(Sender: TObject);
begin
 if BASS_ChannelIsActive(SineStream) = 0 then Exit;
 Effect_Chorus.Down := not Effect_Chorus.Down;
 Effect_ChorusClick(Self);
end;

procedure TsapMP_MainWindow.acCompressorExecute(Sender: TObject);
begin
 if BASS_ChannelIsActive(SineStream) = 0 then Exit;
 Effect_Compresor.Down := not Effect_Compresor.Down;
 Effect_CompresorClick(Self);
end;

procedure TsapMP_MainWindow.acEchoExecute(Sender: TObject);
begin
 if BASS_ChannelIsActive(SineStream) = 0 then Exit;
 Effect_Echo.Down := not Effect_Echo.Down;
 Effect_EchoClick(Self);
end;

procedure TsapMP_MainWindow.acDistortionExecute(Sender: TObject);
begin
 if BASS_ChannelIsActive(SineStream) = 0 then Exit;
 Effect_Distortion.Down := not Effect_Distortion.Down;
 Effect_DistortionClick(Self);
end;

procedure TsapMP_MainWindow.acFlangerExecute(Sender: TObject);
begin
 if BASS_ChannelIsActive(SineStream) = 0 then Exit;
 Effect_Flanger.Down := not Effect_Flanger.Down;
 Effect_FlangerClick(Self);
end;

procedure TsapMP_MainWindow.acGargleExecute(Sender: TObject);
begin
 if BASS_ChannelIsActive(SineStream) = 0 then Exit;
 Effect_Gargle.Down := not Effect_Gargle.Down;
 Effect_GargleClick(Self);
end;

procedure TsapMP_MainWindow.acRotateExecute(Sender: TObject);
begin
 if BASS_ChannelIsActive(SineStream) = 0 then Exit;
 Effect_Rotate.Down := not Effect_Rotate.Down;
 Effect_RotateClick(Self);
end;

procedure TsapMP_MainWindow.FormDestroy(Sender: TObject);
begin
 Timer2.Enabled := False;
 Timer1.Enabled := False;
 Timer3.Enabled := False;
 skButtons.Free;
 xDisplay.Free;
 xBack.Free;
end;

procedure TsapMP_MainWindow.LOADFILE(var Message : TWMCopyData);
var
  copydata : TCopyDataStruct;
  s : String;
  buf : PChar;
begin
 copydata := Message.CopyDataStruct^;
 buf := copydata.lpData;
 SetString(s,buf,Integer(copydata.cbData));
 if FileExists(s) then begin
//     ClearPlayList(sapMP_PlayList.PList);
     if MatchesMask(s,'*.pla') then sapMP_PlayList.PList.LoadPlaylist(s)
     else
     begin
      sapMP_PlayList.PList.Items.Add(s);
      LoadSapMusic(s);
      StartBClick(nil);
     end;
 end;
end;


procedure TsapMP_MainWindow.acInfoExecute(Sender: TObject);
begin
 if sapMP_Info.Visible then begin
  sapMP_Info.Close;
  Exit;
 end;

 sapMP_Info.SetWPos(0,0);
 sapMP_Info.Left := sapMP_MainWindow.Left+sapMP_MainWindow.Width;
 sapMP_Info.Top  := sapMP_MainWindow.Top;
 sapMP_Info.SetSapMPDocked(smdockLeft);
 sapMP_Info.Show;
end;


procedure TsapMP_MainWindow.AddToPlayList(fn :String;Clear : Boolean = False);
begin
 if Assigned(sapMP_PlayList) then
 begin
//  if Clear then ClearPlayList(sapMP_PlayList.pList);
  sapMP_PlayList.pList.Items.Add(fn);
 end;
end;


procedure TsapMP_MainWindow.acConfigExecute(Sender: TObject);
begin
 // Configurattion
 //
end;

procedure TsapMP_MainWindow.PlayLBClick(Sender: TObject);
begin
 //
  case sapMP_PlayList.Visible of
   True  : begin
            sapMP_PlayList.Hide;
{             dmData.PlayLImage.GetBitmap(0,PlayLB.PicIdle.Bitmap);
             dmData.PlayLImage.GetBitmap(0,PlayLB.PicUp.Bitmap);
             dmData.PlayLImage.GetBitmap(1,PlayLB.PicDown.Bitmap);
}           end;
   False : begin
             sapMP_PlayList.Show;
{             dmData.PlayLImage.GetBitmap(2,PlayLB.PicIdle.Bitmap);
             dmData.PlayLImage.GetBitmap(2,PlayLB.PicUp.Bitmap);
             dmData.PlayLImage.GetBitmap(3,PlayLB.PicDown.Bitmap);
}
           end;
  end;
 //
end;

procedure TsapMP_MainWindow.EffectsBClick(Sender: TObject);
begin
  acEffectsParams.Execute;
end;


procedure TsapMP_MainWindow.PaintFrameClick(Sender: TObject);
begin
 case Spectrum.ColWidth of
    1 : Spectrum.ColWidth := 4;
    4 : Spectrum.ColWidth := 1;
 end;
end;

function TsapMP_MainWindow.CheckSilence : Boolean;
var x : DWord;
begin
 Result := False;
 x := 0;
 if not sapMPConfig.cbSilenceDetection.Checked then Exit;
 if BASS_ChannelIsActive(SineStream) = 1 then
 begin
   x:= BASS_ChannelGetLevel(SineStream);
{
   Caption := 'Left: '+IntToStr(HiWord(x))+' Right: '+IntToStr(LoWord(x));
}
   if (HiWord(x) = 1) or (LoWord(x) =1) then Inc(SongSilence);
 end;
 Result := (HiWord(x) = 1) or (LoWord(x) =1);
end;

function TsapMP_MainWindow.EndOfSong: Boolean;
begin
 if sapMPConfig.cbSilenceDetection.Checked then Result := SongSilence>0
 else Result := False;
end;

procedure TsapMP_MainWindow.Timer2Timer(Sender: TObject);
var sn : String;
begin
 PlayTime := IncSecond(PlayTime,1);
  if ((PlayTime > SongTime) and sapMPConfig.cbJumpToNextSong.Checked) then
    if LoadSongFromPlayList(sapMP_PlayList.pList,sn) then
    begin
     LoadSAPMusic(sn);
     StartBClick(nil);
    end;
 DrawPlayTime;
end;

procedure TsapMP_MainWindow.ClearPlayTime;
begin
 PlayTime := EncodeTime(0,0,0,0);
 DrawPlayTime;
end;


procedure TsapMP_MainWindow.DrawPlayTime;
var
 h,m,s,ms : word;
 ss,mm : String[2];
begin
 DecodeTime(PlayTime,h,m,s,ms);
 ClearXBack;

 ss := Format('%.2d',[s]);
 mm := Format('%.2d',[m]);

 if mm[1] <>'0' then
    dmData.Numbers.Draw(xBack.Canvas,49,2,Integer(mm[1])-48);
    dmData.Numbers.Draw(xBack.Canvas,59,2,Integer(mm[2])-48);
    xBack.Canvas.Pixels[70,5]:= $0000D500;
    xBack.Canvas.Pixels[70,6]:= $0000D500;
    xBack.Canvas.Pixels[71,5]:= $0000D500;
    xBack.Canvas.Pixels[71,6]:= $0000D500;

    xBack.Canvas.Pixels[70,11]:= $0000D500;
    xBack.Canvas.Pixels[70,12]:= $0000D500;
    xBack.Canvas.Pixels[71,11]:= $0000D500;
    xBack.Canvas.Pixels[71,12]:= $0000D500;

    dmData.Numbers.Draw(xBack.Canvas,73,2,Integer(ss[1])-48);
    dmData.Numbers.Draw(xBack.Canvas,83,2,Integer(ss[2])-48);
 Spectrum.SetBackGround(True,xBack);
end;

procedure TsapMP_MainWindow.Timer3Timer(Sender: TObject);
var s : char;
   sn : string;
begin
 //  ScrollTimer
  s := Scrolls[1];
  for i:=1 to length(Scrolls)-1 do
  Scrolls[i] := Scrolls[i+1];
  Scrolls[Length(Scrolls)] := s;

  DrawScroll;

  if sapMPConfig.cbSilenceDetection.Checked and (SongSilence<>0) then
  begin
   Dec(SilenceStep);
   if SilenceStep=1 then
    JumpToNext;
  end;
 //
end;

procedure TsapMP_MainWindow.DrawScroll;
var
 sx : integer;
 sy : integer;
 i : integer;
 ch : Char;
 index : integer;
begin
   sx := Width - 10-160;
   dmData.DisplayL.Draw(xDisplay.Canvas,0,0,0);

   sx := sx+4;
   sy := 24;
   for i := 0 to 29 do begin
    index:= GetCharIndex(UpCase(Scrolls[i+1]));
    dmData.Text.Draw(xDisplay.Canvas,4+5*i,5,index);
   end;
   Canvas.CopyRect(Rect(sx,20,sx+160,55),xDisplay.Canvas,Rect(0,0,160,35));
end;

procedure TsapMP_MainWindow.TrayIconClick(Sender: TObject);
begin
  case MinimizeToTray of
    true : begin; MinimizeToTray := False; TrayIcon.ShowMainForm; end;
    false: begin; MinimizeToTray := True; TrayIcon.HideMainForm; end;
  end;  
end;

procedure TsapMP_MainWindow.TrayIconStartup(Sender: TObject;
  var ShowMainForm: Boolean);
begin
 ShowMainForm := True;
end;

procedure TsapMP_MainWindow.acAboutExecute(Sender: TObject);
var
 abBox : TabBox;
begin
 abBox := TabBox.Create(Application);
 abBox.ShowModal;
 abBox.Free;
 abBox := nil;
end;

procedure TsapMP_MainWindow.acEffectsParamsExecute(Sender: TObject);
begin
  case sapMP_Effects.Visible of
   True  : begin
             sapMP_Effects.Hide;
{             dmData.EffectsLImage.GetBitmap(0,EffectsB.PicIdle.Bitmap);
             dmData.EffectsLImage.GetBitmap(0,EffectsB.PicUp.Bitmap);
             dmData.EffectsLImage.GetBitmap(1,EffectsB.PicDown.Bitmap);
}           end;
   False : begin
             sapMP_Effects.SHow;
{             dmData.EffectsLImage.GetBitmap(2,EffectsB.PicIdle.Bitmap);
             dmData.EffectsLImage.GetBitmap(2,EffectsB.PicUp.Bitmap);
             dmData.EffectsLImage.GetBitmap(3,EffectsB.PicDown.Bitmap);
}           end;
  end;
end;

procedure TsapMP_MainWindow.acExitExecute(Sender: TObject);
begin
 Close;
end;

procedure TsapMP_MainWindow.MainMenuPopup(Sender: TObject);
begin
//
  acEffectsParams.Checked := sapMP_Effects.Visible;
  acInfo.Checked := sapMP_Info.Visible;

  pmEfReverb.Checked := Effect_Reverb.Down;
  pmEfChorus.Checked := Effect_Chorus.Down;
  pmEfCompresor.Checked := Effect_Compresor.Down;
  pmEfEcho.Checked := Effect_Echo.Down;
  pmEfDistortion.Checked := Effect_Distortion.Down;
  pmEfFlanger.Checked := Effect_Flanger.Down;
  pmEfGargle.Checked := Effect_Gargle.Down;
end;

procedure TsapMP_MainWindow.acPreferencesExecute(Sender: TObject);
begin
 //
  sapMPConfig.Show;
 //
end;

procedure TsapMP_MainWindow.LoadConfig;
var IniFile:TIniFile;
begin
 IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 if IniFile.SectionExists('OPTIONS') then
 begin
   sapMPConfig.edJumpAfterTime.Text := IniFile.ReadString('OPTIONS','SongTime','5:00');
   SongTime := ConvertTime(IniFile.ReadString('OPTIONS','SongTime','5:00'));
   sapMPConfig.cbSilenceDetection.Checked := IniFile.ReadBool('OPTIONS','SilenceDetection',sapMPConfig.cbSilenceDetection.Checked);
   sapMPConfig.cbJumpToNextSong.Checked := IniFile.ReadBool('OPTIONS','JumpToNextSong',sapMPConfig.cbJumpToNextSong.Checked);
   sapMPConfig.cbJumpDecision.ItemIndex := IniFile.ReadInteger('OPTIONS','JumpDecision',0);
 end;
 IniFile.Free;
end;

procedure TsapMP_MainWindow.SaveConfig;
var IniFile:TIniFile;
begin
 IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 IniFile.WriteBool('OPTIONS','SilenceDetection',sapMPConfig.cbSilenceDetection.Checked);
 IniFile.WriteBool('OPTIONS','JumpTonextSong',sapMPConfig.cbJumpToNextSong.Checked);
 IniFile.WriteString('OPTIONS','SongTime',sapMPConfig.edJumpAfterTime.Text);
 IniFile.WriteInteger('OPTIONS','JumpDecision',sapMPConfig.cbJumpDecision.ItemIndex);
{ if IniFile.SectionExists('OPTIONS') then
 begin
   SongTime := ConvertTime(IniFile.ReadString('OPTIONS','SongTime','5:00'));
 end;
}
 IniFile.Free;
end;

procedure TsapMP_MainWindow.JumpToNext;
var decision : integer;
 sn : string;
begin
 decision := sapMPConfig.cbJumpDecision.ItemIndex;

 case decision of
  0:if LoadSongFromPlayList(sapMP_PlayList.pList,sn) then
     begin
      LoadSAPMusic(sn);
      StartBClick(nil);
     end;
  1: if currentsong = MaxSongs then
     begin
      if LoadSongFromPlayList(sapMP_PlayList.pList,sn) then
       begin
        LoadSAPMusic(sn);
        StartBClick(nil);
       end;
     end
     else UpdateButtons(1);
 end;
end;

procedure TsapMP_MainWindow.Effect_RotateClick(Sender: TObject);
begin
 UpdateEffects(Sender);
end;

procedure TsapMP_MainWindow.tbTempoChange(Sender: TObject);
var
 cp : TPoint;
begin
 //
  If (BASS_ChannelIsActive(SineStream) = 0) Then Exit;
//  BASS_FX_TempoSet(SineStream, tbTempo.Value, -1, -100);
//  tbTempo.Hint := 'Tempo : '+IntToStr(tbTempo.Value)+'%';
  GetCursorPos(cp);
  Application.ActivateHint(cp);
 //
end;

procedure TsapMP_MainWindow.Psychotic1Click(Sender: TObject);
begin
 //
//  BASS_EAXPreset(TMenuItem(Sender).Tag);
 //
end;

procedure TsapMP_MainWindow.tbTempoDblClick(Sender: TObject);
begin
{ tbTempo.Value :=0;
 tbTempoChange(Self);
} 
end;

procedure TsapMP_MainWindow.VolumeBarStopChanged(Sender: TObject);
var
 cp : TPoint; 
begin
  Application.HideHint;
  VolumeBar.Hint := 'Volume : '+IntToStr(VolumeBar.Position)+'%';
  GetCursorPos(cp);
  Application.ActivateHint(cp);
end;

procedure TsapMP_MainWindow.acPlistExecute(Sender: TObject);
begin
 //
 sapMP_PlayList.Show;
 //
end;

initialization
  Saved8087CW := Default8087CW;
  Set8087CW($133f); { Disable all fpu exceptions }

finalization
  Set8087CW(Saved8087CW);
end.





